import { WinboxUIComponent } from './component'

/** Avatar Component */
export declare class WAnchor extends WinboxUIComponent {
  /** Is the anchor fixed */
  affix: boolean;

  /** Set anchor area boundary */
  bounds: number;

  /** Sets the container for anchor scrolling */
  getContainer (): void;

  /** Triggered when the anchor reaches the specified offset from the top of the window */
  offsetTop: number;

  /** Whether the anchor fixed mode displays small dots */
  showInkInFixed: boolean;

  /** Type of anchor container */
  wrapperClass: string;

  /** The style of the anchor container */
  wrapperStyle: object;

  /** Anchor settings customize the highlighted anchor */
  getCurrentAnchor: string;

  /** Anchor roll offset */
  targetOffset: number;

  /** Anchor highlight left style */
  activeLinkStyle: string;
}
