import { WinboxUIComponent } from './component'

/** Use Collapse to store contents. */
export declare class WCollapse extends WinboxUIComponent {
  /** Whether to activate accordion mode */
  accordion: boolean

  /** Currently active panel */
  value: string | number | string[] | number[]

  /** If the collapse is bordered */
  bordered: boolean

  /** Title icon location */
  titleIconPosition: 'left' | 'right'

  /** If the collapse is ghost */
  ghost: boolean
}
