import { WinboxUIComponent } from './component'

/** Avatar Component */
export declare class WTextEllipsis extends WinboxUIComponent {
  /** Text to omit */
  text: string;

  /** Restricted height */
  height: string;

  /** Open limit */
  IsLimitHeight: boolean

  /** Use tooltip */
  useTooltip: boolean;

  /** Tooltip style */
  tooltipTheme: 'dark' | 'light'

  /** Text displayed when defining abbreviations */
  more: string

  /** Style of text */
  textStyle: any

  /** Text class */
  textClass: any
}
