import { WinboxUIComponent } from './component'

/** Timeline Component */

export declare class WTimeline extends WinboxUIComponent {

  /**
   * Set the last ghost node's existence or its content
   * @default false
   * @type any (boolean | string | slot)
   */
  pending: any;

  /**
   * Set the dot of the last ghost node when pending is true
   * @default <Icon type="loading" />
   * @type any (string | slot)
   */
  pendingDot: any;

  /**
   * reverse nodes or not
   * @default false
   * @type boolean
   */
  reverse: boolean;

  /**
   * By sending alternate the timeline will distribute the nodes to the left and right.
   * @default 'left'
   * @type string
   */
  mode: 'left' | 'alternate' | 'right';
}
