<p align="center">
  <img height="100"  width="100" src="https://cdn.jsdelivr.net/npm/winbox-ui/themes/svgIcon/Winbox.svg"/>
</p>

# WinBox

[![npm package](https://img.shields.io/npm/v/winbox-ui.svg?style=flat-square)](https://www.npmjs.org/package/winbox-ui)
![JS gzip size](http://img.badgesize.io/https://unpkg.com/winbox-ui/dist/winbox.esm.js?style=flat-square&compression=gzip&label=gzip%20size:%20JS)
![CSS gzip size](http://img.badgesize.io/https://unpkg.com/winbox-ui/themes/index.css?style=flat-square&compression=gzip&label=gzip%20size:%20CSS)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg?style=flat-square)](LICENSE)

> An UI components library.

## Documentation

visit [winbox.wenge.com](http://winbox.wenge.com).

## Install

```js
npm install winbox-ui --save
```

## Start

### Basic

```html

<script src="https://cdn.jsdelivr.net/npm/vue"></script>
<script src="https://cdn.jsdelivr.net/npm/winbox-ui"></script>
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/winbox-ui/themes/index.css"></link>

```

### Advanced

```js
import Vue from "vue"
import WinboxUI from "winbox-ui"
require("winbox-ui/themes/index.less")

Vue.use(WinboxUI)
```


## Admin Template

[WinboxUI Admin Template](http://fe.wenge.com/admin)


## Browser Support

Modern browsers and Internet Explorer 9+.

## LICENSE

[MIT](https://opensource.org/licenses/MIT)

Copyright (c) 2021-present, Wenge
