import Vue from 'vue'

/** WinboxUI component common definition */
export declare class WinboxUIComponent extends Vue {
  /** Install component into Vue */
  static install (vue: typeof Vue): void
}

/** Component size definition for button, input, etc */
export type WinboxUIComponentSize = 'large' | 'medium' | 'small' 

/** Horizontal alignment */
export type WinboxUIHorizontalAlignment = 'left' | 'center' | 'right'
