import { WinboxUIComponent } from './component'

export type directionType = 'horizontal' | 'vertical' 

export type ContentPosition = 'left' | 'center' | 'right'

/** Divider Component */
export declare class WDivider extends WinboxUIComponent {
  /** enable vertical divider */
  direction: directionType

  /** Sets the location of the split line copy */
  contentPosition: ContentPosition

  /** Is the line a dashed line */
  dashed: boolean

  /** Is the line a plain line */
  plain: boolean
}
