import { WinboxUIComponent } from './component'
import { VNode } from 'vue'

interface WListSlots {
  /* header slot: custom header */
  header: VNode[]

  /* footer slot: custom footer */
  footer: VNode[]

  /* loadMore slot: custom loadMore */
  loadMore: VNode[]

  /* renderItem slot: custom renderItem */
  renderItem: VNode[]

  [key: string]: VNode[]
}

/** List Component */
export declare class WList extends WinboxUIComponent {
  /** Is there a border */
  bordered: boolean

  /** Is there a border */
  extra: any

  /** Is there a border */
  grid: object

  /** Is there a border */
  itemLayout: any

  /** Is there a border */
  loading	: boolean

  /** Is there a border */
  emptyOptions: object

  /** Is there a border */
  size: string

  /** Is there a border */
  split: boolean

  /** Is there a border */
  footer: string

  /** Is there a border */
  header: string

  $slots: WListSlots
}
