import { WinboxUIComponent } from './component'
import { WPopover } from './popover'

/** Popconfirm Component */
export declare class WPopconfirm extends WPopover {
  /** Popconfirm title */
  title: string

  /** Popconfirm ok text */
  confirmButtonText: string
  
  /** Popconfirm cancel text */
  cancelButtonText: string

  /** Popconfirm ok type */
  confirmButtonType: string

  /** Popconfirm cancal type */
  cancelButtonType: string

  /** Popconfirm icon */
  icon: string

  /** Popconfirm icon color */
  iconColor: string

  /** Popconfirm hide icon */
  hideIcon: boolean

  /** Popconfirm placement */
  placement: string

  /** Popconfirm async */
  async: boolean

  /** Popconfirm confirmButtonLoading */
  confirmButtonLoading: boolean
}
