import { WinboxUIComponent } from './component'

export type RadioGroupSize = 'large' | 'medium' | 'small'

/** Radio Group Component */
export declare class WRadioGroup extends WinboxUIComponent {
  /** The size of radio buttons */
  size: RadioGroupSize

  /** Border and background color when button is active */
  fill: string

  /** Whether the nesting radios are disabled */
  disabled: boolean

  /** Font color when button is active */
  textColor: string

  /** The nesting radios mode */
  mode: string

  /** Whether the nesting radios are plain */
  plain: boolean
}
