import { WinboxUIComponent } from './component'

/** MenuItem Component */
export declare class WSubmenu extends WinboxUIComponent {
  /** Unique identification */
  index: string | null

  /** Delay time before showing a sub-menu */
  showTimeout: number

  /** Delay time before hiding a sub-menu */
  hideTimeout: number

  /** Custom class name for the popup menu */
  popperClass: string

  /** Whether the sub-menu is disabled */
  disabled: boolean

  /** Whether to append the popper menu to body */
  popperAppendToBody: boolean

}
